##// END OF EJS Templates
DTB and devices with no wlan
Unknown -
r271:60ebfd79726a
parent child
Show More
@@ -1,760 +1,759
1 1 #!/bin/sh
2 2
3 3 ########################################################################
4 4 # rpi23-gen-image.sh 2015-2017
5 5 #
6 6 # Advanced Debian "jessie", "stretch" and "buster" bootstrap script for RPi2/3
7 7 #
8 8 # This program is free software; you can redistribute it and/or
9 9 # modify it under the terms of the GNU General Public License
10 10 # as published by the Free Software Foundation; either version 2
11 11 # of the License, or (at your option) any later version.
12 12 #
13 13 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
14 14 #
15 15 # Big thanks for patches and enhancements by 20+ github contributors!
16 16 ########################################################################
17 17
18 18 # Are we running as root?
19 19 if [ "$(id -u)" -ne "0" ] ; then
20 20 echo "error: this script must be executed with root privileges!"
21 21 exit 1
22 22 fi
23 23
24 24 # Check if ./functions.sh script exists
25 25 if [ ! -r "./functions.sh" ] ; then
26 26 echo "error: './functions.sh' required script not found!"
27 27 exit 1
28 28 fi
29 29
30 30 # Load utility functions
31 31 . ./functions.sh
32 32
33 33 # Load parameters from configuration template file
34 34 if [ ! -z "$CONFIG_TEMPLATE" ] ; then
35 35 use_template
36 36 fi
37 37
38 38 # Introduce settings
39 39 set -e
40 40 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
41 41 set -x
42 42
43 43 # Raspberry Pi model configuration
44 44 RPI_MODEL=${RPI_MODEL:=2}
45 45
46 46 #bcm2708-rpi-0-w.dtb (Used for Pi 0 and PI 0W)
47 47 RPI0_DTB_FILE=${RPI0_DTB_FILE:=bcm2708-rpi-0-w.dtb}
48 48 RPI0_UBOOT_CONFIG=${RPI0_UBOOT_CONFIG:=rpi_defconfig}
49 49
50 50 #bcm2708-rpi-b.dtb (Used for Pi 1 model A and B)
51 51 RPI1_DTB_FILE=${RPI1_DTB_FILE:=bcm2708-rpi-b.dtb}
52 52 RPI1_UBOOT_CONFIG=${RPI1_UBOOT_CONFIG:=rpi_defconfig}
53 53
54 54 #bcm2708-rpi-b-plus.dtb (Used for Pi 1 model B+ and A+)
55 55 RPI1P_DTB_FILE=${RPI1P_DTB_FILE:=bcm2708-rpi-b-plus.dtb}
56 56 RPI1P_UBOOT_CONFIG=${RPI1P_UBOOT_CONFIG:=rpi_defconfig}
57 57
58 58 #bcm2709-rpi-2-b.dtb (Used for Pi 2 model B)
59 59 RPI2_DTB_FILE=${RPI2_DTB_FILE:=bcm2709-rpi-2-b.dtb}
60 60 RPI2_UBOOT_CONFIG=${RPI2_UBOOT_CONFIG:=rpi_2_defconfig}
61 61
62 62 #bcm2710-rpi-3-b.dtb (Used for Pi 3 model B)
63 63 RPI3_DTB_FILE=${RPI3_DTB_FILE:=bcm2710-rpi-3-b.dtb}
64 64 RPI3_UBOOT_CONFIG=${RPI3_UBOOT_CONFIG:=rpi_3_32b_defconfig}
65 65
66 66 #bcm2710-rpi-3-b-plus.dtb (Used for Pi 3 model B+)
67 67 RPI3P_DTB_FILE=${RPI3P_DTB_FILE:=bcm2710-rpi-3-b-plus.dtb}
68 68 RPI3P_UBOOT_CONFIG=${RPI3P_UBOOT_CONFIG:=rpi_3_32b_defconfig}
69 69
70 70 # Debian release
71 71 RELEASE=${RELEASE:=jessie}
72 72 KERNEL_ARCH=${KERNEL_ARCH:=arm}
73 73 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
74 74 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
75 75 COLLABORA_KERNEL=${COLLABORA_KERNEL:=3.18.0-trunk-rpi2}
76 76 if [ "$KERNEL_ARCH" = "arm64" ] ; then
77 77 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
78 78 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
79 79 fi
80 80
81 81 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
82 82 #RASPBERRY PI 1, PI ZERO, PI ZERO W, AND COMPUTE MODULE DEFAULT Kernel BUILD CONFIGURATION
83 83 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
84 84 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
85 85 else
86 86 #RASPBERRY PI 2, PI 3, PI 3+, AND COMPUTE MODULE 3 DEFAULT Kernel BUILD CONFIGURATION
87 87 #https://www.raspberrypi.org/documentation/linux/kernel/building.md
88 88 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
89 89 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
90 90 fi
91 91
92 92 if [ "$RELEASE_ARCH" = "arm64" ] ; then
93 93 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
94 94 else
95 95 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
96 96 fi
97 97 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
98 98
99 99 # URLs
100 100 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
101 101 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
102 102 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
103 103 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
104 104 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
105 105 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
106 106
107 107 # Build directories
108 108 BASEDIR=${BASEDIR:=$(pwd)/images/${RELEASE}}
109 109 BUILDDIR="${BASEDIR}/build"
110 110
111 111 # Prepare date string for default image file name
112 112 DATE="$(date +%Y-%m-%d)"
113 113 if [ -z "$KERNEL_BRANCH" ] ; then
114 114 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
115 115 else
116 116 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
117 117 fi
118 118
119 119 # Chroot directories
120 120 R="${BUILDDIR}/chroot"
121 121 ETC_DIR="${R}/etc"
122 122 LIB_DIR="${R}/lib"
123 123 BOOT_DIR="${R}/boot/firmware"
124 124 KERNEL_DIR="${R}/usr/src/linux"
125 125 WLAN_FIRMWARE_DIR="${R}/lib/firmware/brcm"
126 126
127 127 # Firmware directory: Blank if download from github
128 128 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
129 129
130 130 # General settings
131 131 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
132 132 PASSWORD=${PASSWORD:=raspberry}
133 133 USER_PASSWORD=${USER_PASSWORD:=raspberry}
134 134 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
135 135 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
136 136 EXPANDROOT=${EXPANDROOT:=true}
137 137
138 138 # Keyboard settings
139 139 XKB_MODEL=${XKB_MODEL:=""}
140 140 XKB_LAYOUT=${XKB_LAYOUT:=""}
141 141 XKB_VARIANT=${XKB_VARIANT:=""}
142 142 XKB_OPTIONS=${XKB_OPTIONS:=""}
143 143
144 144 # Network settings (DHCP)
145 145 ENABLE_DHCP=${ENABLE_DHCP:=true}
146 146
147 147 # Network settings (static)
148 148 NET_ADDRESS=${NET_ADDRESS:=""}
149 149 NET_GATEWAY=${NET_GATEWAY:=""}
150 150 NET_DNS_1=${NET_DNS_1:=""}
151 151 NET_DNS_2=${NET_DNS_2:=""}
152 152 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
153 153 NET_NTP_1=${NET_NTP_1:=""}
154 154 NET_NTP_2=${NET_NTP_2:=""}
155 155
156 156 # APT settings
157 157 APT_PROXY=${APT_PROXY:=""}
158 158 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
159 159
160 160 # Feature settings
161 161 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
162 162 ENABLE_I2C=${ENABLE_I2C:=false}
163 163 ENABLE_SPI=${ENABLE_SPI:=false}
164 164 ENABLE_IPV6=${ENABLE_IPV6:=true}
165 165 ENABLE_SSHD=${ENABLE_SSHD:=true}
166 166 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
167 167 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
168 168 ENABLE_SOUND=${ENABLE_SOUND:=true}
169 169 ENABLE_DBUS=${ENABLE_DBUS:=true}
170 170 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
171 171 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
172 172 ENABLE_XORG=${ENABLE_XORG:=false}
173 173 ENABLE_WM=${ENABLE_WM:=""}
174 174 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
175 175 ENABLE_USER=${ENABLE_USER:=true}
176 176 USER_NAME=${USER_NAME:="pi"}
177 177 ENABLE_ROOT=${ENABLE_ROOT:=false}
178 178 ENABLE_QEMU=${ENABLE_QEMU:=false}
179 179
180 180 # SSH settings
181 181 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
182 182 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
183 183 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
184 184 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
185 185 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
186 186
187 187 # Advanced settings
188 188 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
189 189 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
190 190 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
191 191 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
192 192 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
193 193 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
194 194 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
195 195 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
196 196 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
197 197 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
198 198 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
199 199 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
200 200
201 201 # Kernel compilation settings
202 202 BUILD_KERNEL=${BUILD_KERNEL:=false}
203 203 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
204 204 KERNEL_THREADS=${KERNEL_THREADS:=1}
205 205 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
206 206 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
207 207 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
208 208 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
209 209 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
210 210
211 211 if [ "$KERNEL_ARCH" = "arm64" ] ; then
212 212 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
213 213 else
214 214 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
215 215 fi
216 216
217 217 # Kernel compilation from source directory settings
218 218 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
219 219 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
220 220 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
221 221 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
222 222
223 223 # Reduce disk usage settings
224 224 REDUCE_APT=${REDUCE_APT:=true}
225 225 REDUCE_DOC=${REDUCE_DOC:=true}
226 226 REDUCE_MAN=${REDUCE_MAN:=true}
227 227 REDUCE_VIM=${REDUCE_VIM:=false}
228 228 REDUCE_BASH=${REDUCE_BASH:=false}
229 229 REDUCE_HWDB=${REDUCE_HWDB:=true}
230 230 REDUCE_SSHD=${REDUCE_SSHD:=true}
231 231 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
232 232
233 233 # Encrypted filesystem settings
234 234 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
235 235 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
236 236 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
237 237 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
238 238 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
239 239
240 240 # Chroot scripts directory
241 241 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
242 242
243 243 # Packages required in the chroot build environment
244 244 APT_INCLUDES=${APT_INCLUDES:=""}
245 245 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils"
246 246
247 247 # Packages required for bootstrapping
248 248 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
249 249 MISSING_PACKAGES=""
250 250
251 251 # Packages installed for c/c++ build environment in chroot (keep empty)
252 252 COMPILER_PACKAGES=""
253 253
254 254 set +x
255 255
256 256 # Set Raspberry Pi model specific configuration
257 257 if [ "$RPI_MODEL" = 0 ] ; then
258 DTB_FILE=${RPI2_DTB_FILE}
259 UBOOT_CONFIG=${RPI2_UBOOT_CONFIG}
258 DTB_FILE=${RPI0_DTB_FILE}
259 UBOOT_CONFIG=${RPI0_UBOOT_CONFIG}
260 260 elif [ "$RPI_MODEL" = 1 ] ; then
261 DTB_FILE=${RPI2_DTB_FILE}
262 UBOOT_CONFIG=${RPI2_UBOOT_CONFIG}
261 DTB_FILE=${RPI1_DTB_FILE}
262 UBOOT_CONFIG=${RPI1_UBOOT_CONFIG}
263 263 elif [ "$RPI_MODEL" = 1P ] ; then
264 DTB_FILE=${RPI2_DTB_FILE}
265 UBOOT_CONFIG=${RPI2_UBOOT_CONFIG}
264 DTB_FILE=${RPI1P_DTB_FILE}
265 UBOOT_CONFIG=${RPI1P_UBOOT_CONFIG}
266 266 elif [ "$RPI_MODEL" = 2 ] ; then
267 267 DTB_FILE=${RPI2_DTB_FILE}
268 268 UBOOT_CONFIG=${RPI2_UBOOT_CONFIG}
269 269 elif [ "$RPI_MODEL" = 3 ] ; then
270 270 DTB_FILE=${RPI3_DTB_FILE}
271 271 UBOOT_CONFIG=${RPI3_UBOOT_CONFIG}
272 BUILD_KERNEL=true
273 272 elif [ "$RPI_MODEL" = 3P ] ; then
274 273 DTB_FILE=${RPI3P_DTB_FILE}
275 274 UBOOT_CONFIG=${RPI3P_UBOOT_CONFIG}
276 BUILD_KERNEL=true
277 275 else
278 276 echo "error: Raspberry Pi model ${RPI_MODEL} is not supported!"
279 277 exit 1
280 278 fi
281 279
282 280 # Check if the internal wireless interface is supported by the RPi model
283 if [ "$ENABLE_WIRELESS" = true ] && [ "$RPI_MODEL" = 2 ]; then
281 if [ "$ENABLE_WIRELESS" = true ] && ([ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 2 ]); then
282
284 283 echo "error: The selected Raspberry Pi model has no internal wireless interface"
285 284 exit 1
286 285 fi
287 286
288 287 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
289 288 if [ ! -z "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
290 289 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
291 290 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
292 291 exit 1
293 292 fi
294 293 fi
295 294
296 295 # Build RPi2/3 Linux kernel if required by Debian release
297 296 if [ "$RELEASE" = "stretch" ] || [ "$RELEASE" = "buster" ] ; then
298 297 BUILD_KERNEL=true
299 298 fi
300 299
301 300 # Add packages required for kernel cross compilation
302 301 if [ "$BUILD_KERNEL" = true ] ; then
303 302 if [ "$KERNEL_ARCH" = "arm" ] ; then
304 303 if [ "$RELEASE_ARCH" = "armel" ]; then
305 304 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
306 305 fi
307 306 if [ "$RELEASE_ARCH" = "armhf" ]; then
308 307 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
309 308 fi
310 309 if [ "$RELEASE_ARCH" = "arm64" ]; then
311 310 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
312 311 fi
313 312 fi
314 313 fi
315 314
316 315 # Add libncurses5 to enable kernel menuconfig
317 316 if [ "$KERNEL_MENUCONFIG" = true ] ; then
318 317 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses5-dev"
319 318 fi
320 319
321 320 # Add ccache compiler cache for (faster) kernel cross (re)compilation
322 321 if [ "$KERNEL_CCACHE" = true ] ; then
323 322 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
324 323 fi
325 324
326 325 # Add cryptsetup package to enable filesystem encryption
327 326 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
328 327 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
329 328 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
330 329
331 330 if [ -z "$CRYPTFS_PASSWORD" ] ; then
332 331 echo "error: no password defined (CRYPTFS_PASSWORD)!"
333 332 exit 1
334 333 fi
335 334 ENABLE_INITRAMFS=true
336 335 fi
337 336
338 337 # Add initramfs generation tools
339 338 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
340 339 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
341 340 fi
342 341
343 342 # Add device-tree-compiler required for building the U-Boot bootloader
344 343 if [ "$ENABLE_UBOOT" = true ] ; then
345 344 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler"
346 345 fi
347 346
348 347 # Check if root SSH (v2) public key file exists
349 348 if [ ! -z "$SSH_ROOT_PUB_KEY" ] ; then
350 349 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
351 350 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
352 351 exit 1
353 352 fi
354 353 fi
355 354
356 355 # Check if $USER_NAME SSH (v2) public key file exists
357 356 if [ ! -z "$SSH_USER_PUB_KEY" ] ; then
358 357 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
359 358 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
360 359 exit 1
361 360 fi
362 361 fi
363 362
364 363 # Check if all required packages are installed on the build system
365 364 for package in $REQUIRED_PACKAGES ; do
366 365 if [ "`dpkg-query -W -f='${Status}' $package`" != "install ok installed" ] ; then
367 366 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
368 367 fi
369 368 done
370 369
371 370 # If there are missing packages ask confirmation for install, or exit
372 371 if [ -n "$MISSING_PACKAGES" ] ; then
373 372 echo "the following packages needed by this script are not installed:"
374 373 echo "$MISSING_PACKAGES"
375 374
376 375 echo -n "\ndo you want to install the missing packages right now? [y/n] "
377 376 read confirm
378 377 [ "$confirm" != "y" ] && exit 1
379 378
380 379 # Make sure all missing required packages are installed
381 380 apt-get -qq -y install ${MISSING_PACKAGES}
382 381 fi
383 382
384 383 # Check if ./bootstrap.d directory exists
385 384 if [ ! -d "./bootstrap.d/" ] ; then
386 385 echo "error: './bootstrap.d' required directory not found!"
387 386 exit 1
388 387 fi
389 388
390 389 # Check if ./files directory exists
391 390 if [ ! -d "./files/" ] ; then
392 391 echo "error: './files' required directory not found!"
393 392 exit 1
394 393 fi
395 394
396 395 # Check if specified KERNELSRC_DIR directory exists
397 396 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
398 397 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
399 398 exit 1
400 399 fi
401 400
402 401 # Check if specified UBOOTSRC_DIR directory exists
403 402 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
404 403 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
405 404 exit 1
406 405 fi
407 406
408 407 # Check if specified FBTURBOSRC_DIR directory exists
409 408 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
410 409 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
411 410 exit 1
412 411 fi
413 412
414 413 # Check if specified CHROOT_SCRIPTS directory exists
415 414 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
416 415 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
417 416 exit 1
418 417 fi
419 418
420 419 # Check if specified device mapping already exists (will be used by cryptsetup)
421 420 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
422 421 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
423 422 exit 1
424 423 fi
425 424
426 425 # Don't clobber an old build
427 426 if [ -e "$BUILDDIR" ] ; then
428 427 echo "error: directory ${BUILDDIR} already exists, not proceeding"
429 428 exit 1
430 429 fi
431 430
432 431 # Setup chroot directory
433 432 mkdir -p "${R}"
434 433
435 434 # Check if build directory has enough of free disk space >512MB
436 435 if [ "$(df --output=avail ${BUILDDIR} | sed "1d")" -le "524288" ] ; then
437 436 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
438 437 exit 1
439 438 fi
440 439
441 440 set -x
442 441
443 442 # Call "cleanup" function on various signals and errors
444 443 trap cleanup 0 1 2 3 6
445 444
446 445 # Add required packages for the minbase installation
447 446 if [ "$ENABLE_MINBASE" = true ] ; then
448 447 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
449 448 fi
450 449
451 450 # Add required locales packages
452 451 if [ "$DEFLOCAL" != "en_US.UTF-8" ] ; then
453 452 APT_INCLUDES="${APT_INCLUDES},locales,keyboard-configuration,console-setup"
454 453 fi
455 454
456 455 # Add parted package, required to get partprobe utility
457 456 if [ "$EXPANDROOT" = true ] ; then
458 457 APT_INCLUDES="${APT_INCLUDES},parted"
459 458 fi
460 459
461 460 # Add dbus package, recommended if using systemd
462 461 if [ "$ENABLE_DBUS" = true ] ; then
463 462 APT_INCLUDES="${APT_INCLUDES},dbus"
464 463 fi
465 464
466 465 # Add iptables IPv4/IPv6 package
467 466 if [ "$ENABLE_IPTABLES" = true ] ; then
468 467 APT_INCLUDES="${APT_INCLUDES},iptables"
469 468 fi
470 469
471 470 # Add openssh server package
472 471 if [ "$ENABLE_SSHD" = true ] ; then
473 472 APT_INCLUDES="${APT_INCLUDES},openssh-server"
474 473 fi
475 474
476 475 # Add alsa-utils package
477 476 if [ "$ENABLE_SOUND" = true ] ; then
478 477 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
479 478 fi
480 479
481 480 # Add rng-tools package
482 481 if [ "$ENABLE_HWRANDOM" = true ] ; then
483 482 APT_INCLUDES="${APT_INCLUDES},rng-tools"
484 483 fi
485 484
486 485 # Add fbturbo video driver
487 486 if [ "$ENABLE_FBTURBO" = true ] ; then
488 487 # Enable xorg package dependencies
489 488 ENABLE_XORG=true
490 489 fi
491 490
492 491 # Add user defined window manager package
493 492 if [ -n "$ENABLE_WM" ] ; then
494 493 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
495 494
496 495 # Enable xorg package dependencies
497 496 ENABLE_XORG=true
498 497 fi
499 498
500 499 # Add xorg package
501 500 if [ "$ENABLE_XORG" = true ] ; then
502 501 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
503 502 fi
504 503
505 504 # Replace selected packages with smaller clones
506 505 if [ "$ENABLE_REDUCE" = true ] ; then
507 506 # Add levee package instead of vim-tiny
508 507 if [ "$REDUCE_VIM" = true ] ; then
509 508 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
510 509 fi
511 510
512 511 # Add dropbear package instead of openssh-server
513 512 if [ "$REDUCE_SSHD" = true ] ; then
514 513 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/openssh-server/dropbear/")"
515 514 fi
516 515 fi
517 516
518 517 if [ "$RELEASE" != "jessie" ] ; then
519 518 APT_INCLUDES="${APT_INCLUDES},libnss-systemd"
520 519 fi
521 520
522 521 # Configure kernel sources if no KERNELSRC_DIR
523 522 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
524 523 KERNELSRC_CONFIG=true
525 524 fi
526 525
527 526 # Configure reduced kernel
528 527 if [ "$KERNEL_REDUCE" = true ] ; then
529 528 KERNELSRC_CONFIG=false
530 529 fi
531 530
532 531 # Configure qemu compatible kernel
533 532 if [ "$ENABLE_QEMU" = true ] ; then
534 533 KERNEL_DEFCONFIG="vexpress_defconfig"
535 534 if [ "$KERNEL_MENUCONFIG" = false ] ; then
536 535 KERNEL_OLDDEFCONFIG=true
537 536 fi
538 537 fi
539 538
540 539 # Execute bootstrap scripts
541 540 for SCRIPT in bootstrap.d/*.sh; do
542 541 head -n 3 "$SCRIPT"
543 542 . "$SCRIPT"
544 543 done
545 544
546 545 ## Execute custom bootstrap scripts
547 546 if [ -d "custom.d" ] ; then
548 547 for SCRIPT in custom.d/*.sh; do
549 548 . "$SCRIPT"
550 549 done
551 550 fi
552 551
553 552 # Execute custom scripts inside the chroot
554 553 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
555 554 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
556 555 chroot_exec /bin/bash -x <<'EOF'
557 556 for SCRIPT in /chroot_scripts/* ; do
558 557 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
559 558 $SCRIPT
560 559 fi
561 560 done
562 561 EOF
563 562 rm -rf "${R}/chroot_scripts"
564 563 fi
565 564
566 565 # Remove c/c++ build environment from the chroot
567 566 chroot_remove_cc
568 567
569 568 # Remove apt-utils
570 569 if [ "$RELEASE" = "jessie" ] ; then
571 570 chroot_exec apt-get purge -qq -y --force-yes apt-utils
572 571 fi
573 572
574 573 # Generate required machine-id
575 574 MACHINE_ID=$(dbus-uuidgen)
576 575 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
577 576 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
578 577
579 578 # APT Cleanup
580 579 chroot_exec apt-get -y clean
581 580 chroot_exec apt-get -y autoclean
582 581 chroot_exec apt-get -y autoremove
583 582
584 583 # Unmount mounted filesystems
585 584 umount -l "${R}/proc"
586 585 umount -l "${R}/sys"
587 586
588 587 # Clean up directories
589 588 rm -rf "${R}/run/*"
590 589 rm -rf "${R}/tmp/*"
591 590
592 591 # Clean up files
593 592 rm -f "${ETC_DIR}/ssh/ssh_host_*"
594 593 rm -f "${ETC_DIR}/dropbear/dropbear_*"
595 594 rm -f "${ETC_DIR}/apt/sources.list.save"
596 595 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
597 596 rm -f "${ETC_DIR}/*-"
598 597 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
599 598 rm -f "${ETC_DIR}/resolv.conf"
600 599 rm -f "${R}/root/.bash_history"
601 600 rm -f "${R}/var/lib/urandom/random-seed"
602 601 rm -f "${R}/initrd.img"
603 602 rm -f "${R}/vmlinuz"
604 603 rm -f "${R}${QEMU_BINARY}"
605 604
606 605 if [ "$ENABLE_QEMU" = true ] ; then
607 606 # Setup QEMU directory
608 607 mkdir "${BASEDIR}/qemu"
609 608
610 609 # Copy kernel image to QEMU directory
611 610 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
612 611
613 612 # Copy kernel config to QEMU directory
614 613 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
615 614
616 615 # Copy kernel dtbs to QEMU directory
617 616 for dtb in "${BOOT_DIR}/"*.dtb ; do
618 617 if [ -f "${dtb}" ] ; then
619 618 install_readonly "${dtb}" "${BASEDIR}/qemu/"
620 619 fi
621 620 done
622 621
623 622 # Copy kernel overlays to QEMU directory
624 623 if [ -d "${BOOT_DIR}/overlays" ] ; then
625 624 # Setup overlays dtbs directory
626 625 mkdir "${BASEDIR}/qemu/overlays"
627 626
628 627 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
629 628 if [ -f "${dtb}" ] ; then
630 629 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
631 630 fi
632 631 done
633 632 fi
634 633
635 634 # Copy initramfs to QEMU directory
636 635 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
637 636 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
638 637 fi
639 638 fi
640 639
641 640 # Calculate size of the chroot directory in KB
642 641 CHROOT_SIZE=$(expr `du -s "${R}" | awk '{ print $1 }'`)
643 642
644 643 # Calculate the amount of needed 512 Byte sectors
645 644 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
646 645 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
647 646 ROOT_OFFSET=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS})
648 647
649 648 # The root partition is EXT4
650 649 # This means more space than the actual used space of the chroot is used.
651 650 # As overhead for journaling and reserved blocks 35% are added.
652 651 ROOT_SECTORS=$(expr $(expr ${CHROOT_SIZE} + ${CHROOT_SIZE} \/ 100 \* 35) \* 1024 \/ 512)
653 652
654 653 # Calculate required image size in 512 Byte sectors
655 654 IMAGE_SECTORS=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS})
656 655
657 656 # Prepare image file
658 657 if [ "$ENABLE_SPLITFS" = true ] ; then
659 658 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=${TABLE_SECTORS}
660 659 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek=${FRMW_SECTORS}
661 660 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=${TABLE_SECTORS}
662 661 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek=${ROOT_SECTORS}
663 662
664 663 # Write firmware/boot partition tables
665 664 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
666 665 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
667 666 EOM
668 667
669 668 # Write root partition table
670 669 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
671 670 ${TABLE_SECTORS},${ROOT_SECTORS},83
672 671 EOM
673 672
674 673 # Setup temporary loop devices
675 674 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME-frmw.img)"
676 675 ROOT_LOOP="$(losetup -o 1M -f --show $IMAGE_NAME-root.img)"
677 676 else # ENABLE_SPLITFS=false
678 677 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=${TABLE_SECTORS}
679 678 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek=${IMAGE_SECTORS}
680 679
681 680 # Write partition table
682 681 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
683 682 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
684 683 ${ROOT_OFFSET},${ROOT_SECTORS},83
685 684 EOM
686 685
687 686 # Setup temporary loop devices
688 687 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME.img)"
689 688 ROOT_LOOP="$(losetup -o 65M -f --show $IMAGE_NAME.img)"
690 689 fi
691 690
692 691 if [ "$ENABLE_CRYPTFS" = true ] ; then
693 692 # Create dummy ext4 fs
694 693 mkfs.ext4 "$ROOT_LOOP"
695 694
696 695 # Setup password keyfile
697 696 touch .password
698 697 chmod 600 .password
699 698 echo -n ${CRYPTFS_PASSWORD} > .password
700 699
701 700 # Initialize encrypted partition
702 701 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
703 702
704 703 # Open encrypted partition and setup mapping
705 704 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
706 705
707 706 # Secure delete password keyfile
708 707 shred -zu .password
709 708
710 709 # Update temporary loop device
711 710 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
712 711
713 712 # Wipe encrypted partition (encryption cipher is used for randomness)
714 713 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count=$(blockdev --getsz "${ROOT_LOOP}")
715 714 fi
716 715
717 716 # Build filesystems
718 717 mkfs.vfat "$FRMW_LOOP"
719 718 mkfs.ext4 "$ROOT_LOOP"
720 719
721 720 # Mount the temporary loop devices
722 721 mkdir -p "$BUILDDIR/mount"
723 722 mount "$ROOT_LOOP" "$BUILDDIR/mount"
724 723
725 724 mkdir -p "$BUILDDIR/mount/boot/firmware"
726 725 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
727 726
728 727 # Copy all files from the chroot to the loop device mount point directory
729 728 rsync -a "${R}/" "$BUILDDIR/mount/"
730 729
731 730 # Unmount all temporary loop devices and mount points
732 731 cleanup
733 732
734 733 # Create block map file(s) of image(s)
735 734 if [ "$ENABLE_SPLITFS" = true ] ; then
736 735 # Create block map files for "bmaptool"
737 736 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
738 737 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
739 738
740 739 # Image was successfully created
741 740 echo "$IMAGE_NAME-frmw.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
742 741 echo "$IMAGE_NAME-root.img ($(expr \( ${TABLE_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
743 742 else
744 743 # Create block map file for "bmaptool"
745 744 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
746 745
747 746 # Image was successfully created
748 747 echo "$IMAGE_NAME.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
749 748
750 749 # Create qemu qcow2 image
751 750 if [ "$ENABLE_QEMU" = true ] ; then
752 751 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
753 752 QEMU_SIZE=16G
754 753
755 754 qemu-img convert -f raw -O qcow2 $IMAGE_NAME.img $QEMU_IMAGE.qcow2
756 755 qemu-img resize $QEMU_IMAGE.qcow2 $QEMU_SIZE
757 756
758 757 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
759 758 fi
760 759 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant